# addClaimsToIdToken


## Prerequisites

  

-	Download and install Python 3.7 or later

-	Download the boto3 library using the pip command:

		pip3 install boto3

-	Install the argparse package using pip

		pip3 install argparse

-	Install AWS Command Line Interface

-	Configure AWS Command Line Interface.

-	Download a code editor for Python, we have used Visual Studio Code for this article.

-	Install NodeJS.


## List of files and description


| File Name                         | Function                  | Description                                                                                                                          |
|-----------------------------------|---------------------------|--------------------------------------------------------------------------------------------------------------------------------------|
| add_user_info.py                  | Adding user information   | This script will be used to add users to the Cognito User Pool.                                                                      |
| aws_pretoken_cognito_template.yml | Infrastructure deployment | This is the Cloud Formation Template that describes the resources to be deployed on AWS account.                                     |
| cloud_formation_utils.py          | Utility functions         | Utility function for deploying Cloud Formation                                                                                       |
| cognito_utils.py                  | Utility functions         | Utility functions for configuring Cognito User Pool.                                                                                 |
| ddb_utils.py                      | Utility functions         | Utility functions for configuring DynamoDB database.                                                                                 |
| Lambda_utils.py                   | Utility functions         | Utility functions for configuring the Lambda Function associated with the pre-token-generation trigger.                              |
| pre-token-web-app/                | User Interface            | "The ReactJS website, to be hosted locally, that demonstrates the custom claim added to the Cognito ID Token. "                      |
| setup_pretoken.py                 | Infrastructure deployment | Use this script to deploy resources specified in the aws-pretoken-cognito.template.yml                                               |
| stackInputs.json                  | Infrastructure deployment | Names provides to the Cloud Formation template. User can change these if they choose so.                                             |
| stackOutputs.json                 | Infrastructure deployment | Subset of outputs produced by the deployment of stack. These values are necessary for further configuration of the stack components. This file is generated after you run setup_pretoken.py |



## Review stackInputs.json and then deploy the infrastructure


-  Change the value of 'userPoolDomainName' parameter to a random unique value of your choice.
  

	python3 setup_pretoken.py


- This will generate a stack named pretokenCognito in us-east-1 region of your AWS account. 


## Add users to the Cognito User Pool, run the python script from the addclaimstoidtoken directory as follows:

  
	python3 add_user_info.py
  

## Run the web application

  
Change directory to pre-token-web-app directory. Assuming that you are currently in the addclaimstoidtoken directory, run the following command:

	cd pre-token-web-app

This directory contains a ReactJS application. To run the application, run the following commands on the terminal:

	npm install
	npm start

Use control + c to close the web application.
